## cmake-format 0.6.10

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(tangentsky)
enable_testing()
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

if(NOT CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX
      ${CMAKE_BINARY_DIR}/install
      CACHE PATH "cmake installation directory")
endif()

find_package(Threads REQUIRED)
find_package(fmt)

# NOTE(josh): order matters
set(_tangent_modules
    environment.cmake
    wrappers.cmake
    codestyle.cmake
    ctest_helpers.cmake
    debian.cmake
    doctools.cmake
    pkgconfig.cmake
    re2-config.cmake)
foreach(module ${_tangent_modules})
  include(${CMAKE_SOURCE_DIR}/cmake/${module})
endforeach()

detect_buildenv()
if(TANGENT_SPARSE_EXPORT)
  message(STATUS "Detected sparse export: ${TANGENT_SPARSE_EXPORT}")
endif()

if(NOT TANGENT_BUILD_CONTEXT)
  set(TANGENT_BUILD_CONTEXT
      WORKSTATION
      CACHE STRING "what is the context for the current build")
endif()

if(TANGENT_SPARSE_EXPORT OR TANGENT_IS_DEBIAN_BUILD)
  # NOTE(josh): The order must be topological in dependency graph
  foreach(exportname libtangent-util libtangent-json argue)
    find_package(${exportname} QUIET CONFIG)
  endforeach()
endif()

# cmake-lint: disable=E1122
pkg_find(
  PKG eigen3
  PKG fontconfig
  PKG freetype2
  PKG fuse
  PKG glib-2.0
  PKG gnuradio-osmosdr
  PKG gnuradio-filter
  PKG gtk+-3.0
  PKG gtkmm-3.0
  PKG libcurl
  PKG libelf
  PKG libglog
  PKG libpng NAMES libpng12 libpng16
  PKG librtlsdr
  PKG libudev
  PKG openssl
  PKG tinyxml2
  PKG vulkan
  PKG x11-xcb)

# TODO(josh): can we get rid of these with some interface libraries?
include_directories(${CMAKE_SOURCE_DIR})
include_directories(${CMAKE_SOURCE_DIR}/third_party/googletest/include)
include_directories(${CMAKE_SOURCE_DIR}/third_party/glm)

set(CXX_STANDARD
    "c++11"
    CACHE STRING "argument to '-std=' for C++ compiler")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=${CXX_STANDARD}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -rdynamic")

add_custom_target(chkfmt)
add_custom_target(doc)
add_custom_target(format)
add_custom_target(gen)
add_custom_target(lint)
add_custom_target(test-deps)
add_custom_target(wheels)

set(ENV{PYTHONPATH} ${CMAKE_SOURCE_DIR})
set(CTEST_ENVIRONMENT "PYTHONPATH=${CMAKE_SOURCE_DIR}")

# Will be populated by subdirectory listfiles with the dependencies of the
# master sphinx build
set_property(GLOBAL PROPERTY global_doc_files "")

add_custom_command(
  OUTPUT __always_rebuild
  COMMAND cmake -E echo "" > /dev/null
  COMMENT "Stubbing __always_rebuild")

add_custom_target(
  check-codestyle-manifest ALL
  COMMAND
    python -Bsm tangent.tooling.generate_style_manifest #
    --outfile ${CMAKE_BINARY_DIR}/codestyle_manifest.cmake #
    --excludes-from ${CMAKE_SOURCE_DIR}/cmake/lint-excludes.txt #
    -- ${CMAKE_SOURCE_DIR}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  DEPENDS __always_rebuild
  COMMENT "Checking for changes in codestyle manifest")

check_call(
  COMMAND
    python -Bsm tangent.tooling.generate_style_manifest #
    --outfile ${CMAKE_BINARY_DIR}/codestyle_manifest.cmake #
    --excludes-from ${CMAKE_SOURCE_DIR}/cmake/lint-excludes.txt #
    -- ${CMAKE_SOURCE_DIR}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

# If the manifest changes, then we need to rerun cmake to import link/fmt rules
# for the new manifest
configure_file(${CMAKE_BINARY_DIR}/codestyle_manifest.cmake
               ${CMAKE_BINARY_DIR}/codestyle_manifest.stamp COPYONLY)

include(${CMAKE_BINARY_DIR}/codestyle_manifest.cmake)

# NOTE(josh): search through the list of child directories and add any that
# actually contain a listfile. While globs are evil, this is necessary for
# sparse checkouts. We can and should correctly add dependencies for this glob
# in order to retrigger cmake.
file(
  GLOB children
  RELATIVE ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/*)
foreach(child ${children})
  if(EXISTS ${CMAKE_SOURCE_DIR}/${child}/CMakeLists.txt)
    message("Enabling subdirectory '${child}' for this checkout")
    add_subdirectory(${child})
  endif()
endforeach()

# NOTE(josh): some sparse checkouts don't include doxygen
if(EXISTS ${CMAKE_SOURCE_DIR}/doxy.config.in)
  # configure the doxygen configuration
  # NOTE(josh): maybe want to expose this for editor integration
  # ~~~
  # set(DOXY_WARN_FORMAT "\"$file($line) : $text \"")
  # set(DOXY_WARN_FORMAT "\"$file:$line: $text \"")
  # ~~~
  configure_file("${PROJECT_SOURCE_DIR}/doxy.config.in"
                 "${PROJECT_BINARY_DIR}/doxy.config")

  add_custom_command(
    OUTPUT ${PROJECT_BINARY_DIR}/doxy.stamp
    COMMAND doxygen ${PROJECT_BINARY_DIR}/doxy.config
    COMMAND touch ${PROJECT_BINARY_DIR}/doxy.stamp
    DEPENDS ${PROJECT_BINARY_DIR}/doxy.config
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

  add_custom_target(doxygen DEPENDS ${PROJECT_BINARY_DIR}/doxy.stamp)
  add_dependencies(doc doxygen)
endif()

add_custom_target(
  better-test
  DEPENDS test-deps
  COMMAND ctest --force-new-ctest-process --output-on-failure
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  COMMENT "Execute ctest")

add_custom_target(
  buildbot-test
  DEPENDS test-deps
  COMMAND
    # cmake-format: off
    ctest
    --label-exclude CI_DISABLED
    --force-new-ctest-process
    --output-on-failure
    --output-log ${CMAKE_BINARY_DIR}/ctestlog.txt
    # cmake-format: on
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

add_custom_target(pre-push)
add_dependencies(pre-push lint chkfmt)

add_custom_target(pre-release)
add_dependencies(pre-release better-test doc lint chkfmt)

=== Makefile ===
# Requirements (based on ubuntu 16.04)
# apt-get install
#		python-pip
#   cmake
#
# pip install --upgrade pip
# pip install --user
#   autopep8
#   flake8
#   pylint
#   sphinx
#

mkfile_path := $(abspath $(lastword $(MAKEFILE_LIST)))
current_dir := $(notdir $(patsubst %/,%,$(dir $(mkfile_path))))

export PYTHONPATH=$(current_dir)

% : .build/Makefile
	@echo "Real build system"
	cd .build/ && env -u MAKELEVEL $(MAKE) $@
all:

test: all

.build/Makefile:
	@echo "Bootstraping build system"
	mkdir -p .build
	touch .build/CMakeCache.txt
	cd .build && env cmake ../

PHONY: all doc test

=== cmake_format/CMakeLists.txt ===
set(_testnames invocation_tests layout_tests lexer_tests markup_tests
               parser_tests)

foreach(testname ${_testnames})
  add_test(
    NAME cmake_format-${testname}
    COMMAND python -Bm cmake_format.${testname}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endforeach()

if(NOT IS_TRAVIS_CI)
  foreach(testname ${_testnames})
    add_test(
      NAME cmake_format-${testname}_py3
      COMMAND python3 -Bm cmake_format.${testname}
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  endforeach()
endif()

set(_genfiles)
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/parse/variables.py
  COMMAND python -Bm cmake_format.tools.parse_cmake_help --outfile
          cmake_format/parse/variables.py variables
  DEPENDS tools/parse_cmake_help.py tools/variables.jinja.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Generating variables.py")
list(APPEND _genfiles ${CMAKE_CURRENT_SOURCE_DIR}/parse/variables.py)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/parse/properties.py
  COMMAND python -Bm cmake_format.tools.parse_cmake_help --outfile
          cmake_format/parse/properties.py properties
  DEPENDS tools/parse_cmake_help.py tools/properties.jinja.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Generating properties.py")
list(APPEND _genfiles ${CMAKE_CURRENT_SOURCE_DIR}/parse/properties.py)

add_custom_target(gen-cmake_format DEPENDS ${_genfiles})
add_dependencies(gen gen-cmake_format)

# NOTE(josh): this is just here to induce a dependency on the configure step. If
# we change the version number in __init__.py we need to re-run cmake so we can
# get out the version number and create rules for the distribution files.
configure_file(__init__.py init.stamp COPYONLY)

execute_process(
  COMMAND python -Bm cmake_format --version
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  RESULT_VARIABLE _resultcode
  OUTPUT_VARIABLE _src_version
  OUTPUT_STRIP_TRAILING_WHITESPACE)
if(NOT _resultcode EQUAL 0)
  message(
    FATAL_ERROR "Failed to get cmake-format version number from __init__.py")
endif()

# NOTE(josh): python uses dot to separate pre-release while node uses dash
string(REGEX REPLACE "([0-9]+\\.[0-9]+\\.[0-9]+)\\.(.*)" "\\1-\\2"
                     _extension_version "${_src_version}")

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/.egg
  COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/.egg
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

set(_distdir ${CMAKE_CURRENT_BINARY_DIR}/dist)
add_custom_command(
  OUTPUT ${_distdir}/cmake_format-${_src_version}.tar.gz
         ${_distdir}/cmake_format-${_src_version}-py3-none-any.whl
  COMMAND
    # cmake-format: off
    python cmake_format/pypi/setup.py
    build --build-base ${CMAKE_CURRENT_BINARY_DIR}
    egg_info --egg-base ${CMAKE_CURRENT_BINARY_DIR}/.egg
    bdist_wheel
      --bdist-dir ${CMAKE_CURRENT_BINARY_DIR}/bdist
      --dist-dir ${_distdir}
    sdist --dist-dir ${_distdir}
    # cmake-format: on
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/.egg
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

add_custom_target(
  cmake_format-wheel
  DEPENDS ${_distdir}/cmake_format-${_src_version}-py3-none-any.whl)
add_dependencies(wheels cmake_format-wheel)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.rst
  COMMAND
    python -Bm tangent.tooling.get_release_notes
    cmake_format/doc/release_notes.rst \$\${TRAVIS_TAG} -o
    ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.rst
  DEPENDS doc/release_notes.rst
          ${CMAKE_SOURCE_DIR}/tangent/tooling/get_release_notes.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.md
  COMMAND
    pandoc -s -o ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.md
    ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.rst
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.rst
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

add_subdirectory(command_tests)
add_subdirectory(contrib)
add_subdirectory(doc)
add_subdirectory(test)
add_subdirectory(vscode_extension)

set(_vscedir ${CMAKE_CURRENT_BINARY_DIR}/vscode_extension)
add_custom_target(
  push-cmake_format-github-release
  COMMAND
    # cmake-format: off
    python -Bm tangent.tooling.github push-release
      --message ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.md
      cheshirekow/cmake_format \$\${TRAVIS_TAG}
      ${_distdir}/cmake_format-${_src_version}.tar.gz
      ${_distdir}/cmake_format-${_src_version}-py3-none-any.whl
      ${_vscedir}/cmake-format-${_extension_version}.vsix
    # cmake-format: on
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.md
          ${_distdir}/cmake_format-${_src_version}.tar.gz
          ${_distdir}/cmake_format-${_src_version}-py3-none-any.whl
          # ${_vscedir}/cmake-format-${_extension_version}.vsix
  COMMENT "Uploading release artifacts"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

# NOTE(josh): cmake is broken. It fails to produce an accurate build system when
# we correctly specify the .vsix path in the above rule. We must use target
# level dependencies to get the correct order of operations and then omit the
# actual file-level dependency.
add_dependencies(push-cmake_format-github-release vscode-extension)

=== tangent/CMakeLists.txt ===
set(_subdirs gtkutil json util tooling)
foreach(subdir ${_subdirs})
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${subdir}/CMakeLists.txt)
    add_subdirectory(${subdir})
  endif()
endforeach()

=== cmake_format/doc/CMakeLists.txt ===
#
# Generated source bits for sphinx documentation
#
set(_stage ${CMAKE_CURRENT_BINARY_DIR}/stage)
set(_genbits)

add_custom_command(
  OUTPUT ${_stage}/bits
  COMMAND ${CMAKE_COMMAND} -E make_directory ${_stage}/bits
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Creating directory ${_stage}/bits")

set(_config_deps
    ../__main__.py #
    ../configuration.py #
    ../config_util.py)

add_custom_command(
  OUTPUT ${_stage}/bits/format-usage.txt
  COMMAND python -Bm cmake_format --help > ${_stage}/bits/format-usage.txt
  DEPENDS ${_stage}/bits #
          ${_config_deps}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/format-usage.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/format-usage-short.txt ${_stage}/bits/common-usage.txt
  COMMAND
    python -Bm cmake_format.tools.split_help ${_stage}/bits/format-usage.txt
    ${_stage}/bits/format-usage-short.txt ${_stage}/bits/common-usage.txt
  DEPENDS ${_stage}/bits/format-usage.txt ../tools/split_help.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/format-usage-short.txt
     ${_stage}/bits/common-usage.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/annotate-usage.txt
  COMMAND python -Bm cmake_format.annotate --help >
          ${_stage}/bits/annotate-usage.txt
  DEPENDS ${_stage}/bits #
          ${_config_deps} ../annotate.py #
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/annotate-usage.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/ctest-to-usage.txt
  COMMAND python -Bm cmake_format.ctest_to --help >
          ${_stage}/bits/ctest-to-usage.txt
  DEPENDS ${_stage}/bits #
          ${_config_deps} ../ctest_to.py #
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/ctest-to-usage.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/lint-usage.txt
  COMMAND python -Bm cmake_lint --help > ${_stage}/bits/lint-usage.txt
  DEPENDS ${_stage}/bits #
          ${_config_deps} #
          ../../cmake_lint/__main__.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/lint-usage.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/lint-usage-short.txt
  COMMAND python -Bm cmake_format.tools.split_help ${_stage}/bits/lint-usage.txt
          ${_stage}/bits/lint-usage-short.txt
  DEPENDS ${_stage}/bits/lint-usage.txt ../tools/split_help.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/lint-usage-short.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/configbits.py
  COMMAND python -Bm cmake_format --dump-config > ${_stage}/bits/configbits.py
  DEPENDS ${_stage}/bits #
          ${_config_deps}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/configbits.py)

add_custom_command(
  OUTPUT ${_stage}/bits/lint-in.cmake
  COMMAND ${CMAKE_COMMAND} -E copy cmake_lint/test/expect_lint.cmake
          ${_stage}/bits/lint-in.cmake
  DEPENDS ${_stage}/bits #
          ${CMAKE_SOURCE_DIR}/cmake_lint/test/expect_lint.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/lint-in.cmake)

add_custom_command(
  OUTPUT ${_stage}/bits/lint-out.cmake
  COMMAND python -Bm cmake_lint cmake_lint/test/expect_lint.cmake >
          ${_stage}/bits/lint-out.cmake || echo "OK"
  DEPENDS ${_stage}/bits #
          ../../cmake_lint/__main__.py #
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/lint-out.cmake)

add_custom_command(
  OUTPUT ${_stage}/bits/dump-example-src.cmake
  COMMAND ${CMAKE_COMMAND} -E copy cmake_format/doc/bits/dump-example.cmake
          ${_stage}/bits/dump-example-src.cmake
  DEPENDS ${_stage}/bits #
          bits/dump-example.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/dump-example-src.cmake)

add_custom_command(
  OUTPUT ${_stage}/bits/dump-example-lex.txt
  COMMAND
    python -Bm cmake_format --dump lex ${_stage}/bits/dump-example-src.cmake >
    ${_stage}/bits/dump-example-lex.txt
  DEPENDS ${_stage}/bits #
          ../../cmake_format/__main__.py #
          ${_stage}/bits/dump-example-src.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/dump-example-lex.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/dump-example-parse.txt
  COMMAND
    python -Bm cmake_format --dump parse
    cmake_format/doc/bits/dump-example.cmake >
    ${_stage}/bits/dump-example-parse.txt
  DEPENDS ${_stage}/bits #
          ../../cmake_format/__main__.py #
          ${_stage}/bits/dump-example-src.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/dump-example-parse.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/dump-example-layout.txt
  COMMAND
    python -Bm cmake_format --dump layout
    cmake_format/doc/bits/dump-example.cmake >
    ${_stage}/bits/dump-example-layout.txt
  DEPENDS ${_stage}/bits #
          ../../cmake_format/__main__.py #
          ${_stage}/bits/dump-example-src.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/dump-example-layout.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/example-in.cmake
  COMMAND ${CMAKE_COMMAND} -E copy cmake_format/test/test_in.cmake
          ${_stage}/bits/example-in.cmake
  DEPENDS ${_stage}/bits #
          ../test/test_in.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/example-in.cmake)

add_custom_command(
  OUTPUT ${_stage}/bits/example-out.cmake
  COMMAND ${CMAKE_COMMAND} -E copy cmake_format/test/test_out.cmake
          ${_stage}/bits/example-out.cmake
  DEPENDS ${_stage}/bits #
          ../test/test_out.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/example-out.cmake)

add_custom_command(
  OUTPUT ${_stage}/bits/lintimpl-table.rst
  COMMAND python -Bm cmake_lint.gendocs table >
          ${_stage}/bits/lintimpl-table.rst
  DEPENDS ${_stage}/bits #
          ../../cmake_lint/lintdb.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/lintimpl-table.rst)

add_custom_command(
  OUTPUT ${_stage}/bits/features.rst
  COMMAND tail -n +5 cmake_format/doc/format-features.rst >
          ${_stage}/bits/features.rst
  DEPENDS ${_stage}/bits #
          format-features.rst
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/features.rst)

add_custom_command(
  OUTPUT ${_stage}/lint-implemented.rst
  COMMAND python -Bm cmake_lint.gendocs reference >
          ${_stage}/lint-implemented.rst
  DEPENDS ${_stage}/bits #
          ../../cmake_lint/lintdb.py ../../cmake_lint/gendocs.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/lint-implemented.rst)

add_custom_command(
  OUTPUT ${_stage}/example_rendered.html
  COMMAND python -Bm cmake_format.annotate --format iframe
          cmake_format/test/test_out.cmake > ${_stage}/example_rendered.html
  DEPENDS ${_stage}/bits #
          ../annotate.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/example_rendered.html)

add_custom_command(
  OUTPUT ${_stage}/configopts.rst
  COMMAND python -Bm cmake_format.tools.gen_config_details >
          ${_stage}/configopts.rst
  DEPENDS ../config_util.py #
          ../configuration.py #
          ../tools/gen_config_details.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/configopts.rst)

# TODO(josh): remove this iteration for just one file.
set(_genfiles)
set(_insource_genfiles README.rst)
foreach(genfile ${_insource_genfiles})
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
    COMMAND python -Bm cmake_format.doc.gendoc --bits ${_stage}/bits
            ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
    # TODO(josh): not every file depends on every bit, so this is overkill, but
    # whatever... it's fine for now. We'll need more complicated code if we want
    # to actually declare which bits each file depends on.
    DEPENDS ${_genbits} gendoc.py
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  list(APPEND _genfiles ${CMAKE_CURRENT_SOURCE_DIR}/${genfile})

  add_custom_target(
    run.cmake_format-doc-verify-${genfile}
    COMMAND python -Bm cmake_format.doc.gendoc --verify --bits ${_stage}/bits
            ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

  add_test(
    NAME cmake_format-doc-verify-${genfile}
    COMMAND python -Bm cmake_format.doc.gendoc --verify --bits ${_stage}/bits
            ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endforeach()
add_custom_target(genbits-cmake_format DEPENDS ${_genbits})
add_dependencies(test-deps genbits-cmake_format)
add_custom_target(genfiles-cmake_format DEPENDS ${_genfiles})
add_dependencies(gen genfiles-cmake_format)

# copy sourcefiles from the sourcetree into the build tree so that they're all
# accessible from one tree
set(_copyfiles)
set(_docsources
    .readthedocs.yml
    bits/dump-example.cmake
    changelog.rst
    cmake-annotate.rst
    cmake-format.rst
    cmake-lint.rst
    configuration.rst
    conf.py
    contributing.rst
    ctest-to.rst
    custom_parsers.rst
    format-algorithm.rst
    format-case_studies.rst
    format-example.rst
    format-features.rst
    format-usage.rst
    index.rst
    installation.rst
    lint-example.rst
    lint-notes.rst
    lint-summary.rst
    lint-usage.rst
    modules.rst
    parse-algorithm.rst
    parse-automatic.rst
    parse-tree.rst
    release_notes.rst
    release_process.rst
    release-pipeline.svg)
foreach(docsource ${_docsources})
  add_custom_command(
    OUTPUT ${_stage}/${docsource}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/${docsource}
            ${_stage}/${docsource}
    DEPENDS ${docsource} ${_stage}/bits)
  list(APPEND _copyfiles ${_stage}/${docsource})
endforeach()

# For the subproject build, also copy some of the common files into the build
# tree.
add_custom_command(
  OUTPUT ${_stage}/conf_common.py
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/doc/conf.py
          ${_stage}/conf_common.py)
list(APPEND _copyfiles ${_stage}/conf_common.py)

add_custom_command(
  OUTPUT ${_stage}/sphinx-static/css/cheshire_theme.css
  COMMAND
    ${CMAKE_COMMAND} -E copy
    ${CMAKE_SOURCE_DIR}/doc/sphinx-static/css/cheshire_theme.css
    ${_stage}/sphinx-static/css/cheshire_theme.css
  DEPENDS ${_stage}/bits)
list(APPEND _copyfiles ${_stage}/sphinx-static/css/cheshire_theme.css)

add_custom_command(
  OUTPUT ${_stage}/rtd-requirements.txt
  COMMAND python -Bm cmake_format.tools.gen_rtd_requirements \$\${TRAVIS_TAG}
          ${_src_version} -o ${_stage}/rtd-requirements.txt
  DEPENDS ${CMAKE_SOURCE_DIR}/cmake_format/tools/gen_rtd_requirements.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/rtd-requirements.txt)

set(_sphinx_manifest ${_genbits} ${_copyfiles})
list(SORT _sphinx_manifest)

# NOTE(josh): cmake 3.10 does not have list(JOIN)
string(REPLACE ";" "\n" _manifest_text "${_sphinx_manifest}")

# NOTE(josh): don't use file(WRITE) because that wont create a dependency on the
# configure step to rerun cmake if the file is missing
configure_file(MANIFEST.in ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST
               NEWLINE_STYLE UNIX)

add_custom_target(
  clean-cmake_format-sphinx-stage
  DEPENDS ${_sphinx_manifest} ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST
  COMMAND python -Bm tangent.tooling.clean_stage
          ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST ${_stage}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Cleaning cmake_format/doc/stage")

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/html/index.html
  COMMAND env PYTHONPATH=${CMAKE_SOURCE_DIR} sphinx-build -M html ${_stage}
          ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND touch ${CMAKE_CURRENT_BINARY_DIR}/html/index.html
  DEPENDS clean-cmake_format-sphinx-stage ${_sphinx_manifest}
          ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST ${CMAKE_SOURCE_DIR}/doc/conf.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}

=== tangent/tooling/CMakeLists.txt ===
add_custom_target(
  update-export
  COMMAND python -Bm tangent.tooling.export_sparse_subrepo update
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Updating sparse export")

add_custom_target(
  verify-export
  COMMAND python -Bm tangent.tooling.export_sparse_subrepo verify
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "verify sparse export")

add_test(
  NAME verify-export
  COMMAND python -Bm tangent.tooling.export_sparse_subrepo verify
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== debian/changelog ===
cmake-format (0.6.10-2) unstable; urgency=medium

  * Remove stray debug from debian/rules
  * Include upstream URL in manpages
  * Correct repository on salsa.

 -- Ian Campbell <ijc@debian.org>  Sat, 13 Jun 2020 11:03:42 +0100

cmake-format (0.6.10-1) unstable; urgency=medium

  * Initial packaging. (Closes: #958806)

 -- Ian Campbell <ijc@debian.org>  Fri, 01 May 2020 14:05:22 +0800

=== debian/control ===
Source: cmake-format
Maintainer: Ian Campbell <ijc@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 12),
               dh-python,
               dh-sequence-python3,
               cmake,
               python3,
               python3-setuptools,
               python3-six,
               python3-argparse-manpage
Standards-Version: 4.5.0.1
Vcs-Browser: https://salsa.debian.org/debian/cmake_format
Vcs-Git: https://salsa.debian.org/debian/cmake_format.git
Homepage: https://github.com/cheshirekow/cmake_format
Rules-Requires-Root: no

Package: cmake-format
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
         python3-pkg-resources
Recommends: python3-jinja2
Description: source code formatter for cmake listfiles
 Contains several utilities for formatting and linting cmake
 configuration files.
 .
  * cmake-annotate can generate pretty HTML from your
    listfiles.
  * cmake-format can format your listfiles nicely.
  * cmake-lint can check your listfiles for problems

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	# Force pybuild otherwise makefile is used.
	dh $@ --buildsystem=pybuild

GEN_MANPAGE := PYTHONPATH=$(CURDIR) argparse-manpage  --function get_argparser --author='Josh Bialkowski' --author-email=josh.bialkowski@gmail.com --url=https://github.com/cheshirekow/cmake_format
override_dh_auto_install:
	dh_auto_install

	mkdir -p debian/cmake-format/usr/share/man/man1
	$(GEN_MANPAGE) --project-name=cmake-format     --pyfile ./cmake_format/__main__.py   --output debian/cmake-format/usr/share/man/man1/cmake-format.1
	$(GEN_MANPAGE) --project-name=cmake-annotate   --pyfile ./cmake_format/annotate.py   --output debian/cmake-format/usr/share/man/man1/cmake-annotate.1
	$(GEN_MANPAGE) --project-name=cmake-genparsers --pyfile ./cmake_format/genparsers.py --output debian/cmake-format/usr/share/man/man1/cmake-genparsers.1
	$(GEN_MANPAGE) --project-name=cmake-lint       --pyfile ./cmake_lint/__main__.py     --output debian/cmake-format/usr/share/man/man1/cmake-lint.1

override_dh_auto_test:
	PYBUILD_TEST_BASE_OVERRIDE=$(CURDIR) dh_auto_test

## cmake-format 0.6.11

=== cmake_format/CMakeLists.txt ===
--- 
+++ 
@@ -89,7 +89,7 @@
 add_custom_command(
   OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.rst
   COMMAND
-    python -Bm tangent.tooling.get_release_notes
+    python -B ${TANGENT_TOOLING}/get_release_notes.py
     cmake_format/doc/release_notes.rst \$\${TRAVIS_TAG} -o
     ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.rst
   DEPENDS doc/release_notes.rst
@@ -115,9 +115,10 @@
   push-cmake_format-github-release
   COMMAND
     # cmake-format: off
-    python -Bm tangent.tooling.github push-release
+    python -B ${TANGENT_TOOLING}/github.py push-release
       --message ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.md
-      cheshirekow/cmake_format \$\${TRAVIS_TAG}
+      --repo-slug cheshirekow/cmake_format
+      --tag from-travis
       ${_distdir}/cmake_format-${_src_version}.tar.gz
       ${_distdir}/cmake_format-${_src_version}-py3-none-any.whl
       ${_vscedir}/cmake-format-${_extension_version}.vsix

=== cmake_lint/CMakeLists.txt ===
set(_genfiles ${CMAKE_CURRENT_SOURCE_DIR}/test/expect_lint.cmake
              ${CMAKE_CURRENT_SOURCE_DIR}/test/lint_tests.cmake)
add_custom_command(
  OUTPUT ${_genfiles}
  COMMAND python -Bm cmake_lint.test.genfiles
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
add_custom_target(cmake_lint-test-genfiles DEPENDS ${_genfiles})
add_dependencies(gen cmake_lint-test-genfiles)

foreach(testcase TestFormatFiles ConfigTestCase LintTests)
  add_test(
    NAME cmake_lint-${testcase}
    COMMAND python -Bm cmake_lint.test ${testcase}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endforeach()

=== cmake_format/command_tests/CMakeLists.txt ===
set(MODPREFIX cmake_format.command_tests)

set(_testnames
    TestAddCustomCommand
    TestAddExecutableCommand
    TestAddLibraryCommand
    TestConditional
    TestExport
    TestFile
    TestForeach
    TestInstall
    TestMiscFormatting
    TestSetTargetProperties
    TestSet)

foreach(testname ${_testnames})
  add_test(
    NAME cmake_format-${testname}
    COMMAND python -Bm ${MODPREFIX} ${testname}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endforeach()

if(NOT IS_TRAVIS_CI)
  foreach(testname ${_testnames})
    add_test(
      NAME cmake_format-${testname}_py3
      COMMAND python3 -Bm ${MODPREFIX} ${testname}
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  endforeach()
endif()

=== cmake_format/contrib/CMakeLists.txt ===
add_test(
  NAME cmake_format-validate-pullrequest
  COMMAND python -Bm cmake_format.contrib.validate_pullrequest
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

add_test(
  NAME cmake_format-validate-database
  COMMAND python -Bm cmake_format.contrib.validate_database
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== cmake_format/doc/CMakeLists.txt ===
--- 
+++ 
@@ -208,25 +208,25 @@
 foreach(genfile ${_insource_genfiles})
   add_custom_command(
     OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
-    COMMAND python -Bm cmake_format.doc.gendoc --bits ${_stage}/bits
+    COMMAND python -B ${TANGENT_TOOLING}/gendoc.py --bits ${_stage}/bits
             ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
     # TODO(josh): not every file depends on every bit, so this is overkill, but
     # whatever... it's fine for now. We'll need more complicated code if we want
     # to actually declare which bits each file depends on.
-    DEPENDS ${_genbits} gendoc.py
+    DEPENDS ${_genbits} ${TANGENT_TOOLING}/gendoc.py
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
   list(APPEND _genfiles ${CMAKE_CURRENT_SOURCE_DIR}/${genfile})
 
   add_custom_target(
     run.cmake_format-doc-verify-${genfile}
-    COMMAND python -Bm cmake_format.doc.gendoc --verify --bits ${_stage}/bits
-            ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
+    COMMAND python -B ${TANGENT_TOOLING}/gendoc.py --verify --bits
+            ${_stage}/bits ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 
   add_test(
     NAME cmake_format-doc-verify-${genfile}
-    COMMAND python -Bm cmake_format.doc.gendoc --verify --bits ${_stage}/bits
-            ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
+    COMMAND python -B ${TANGENT_TOOLING}/gendoc.py --verify --bits
+            ${_stage}/bits ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 endforeach()
 add_custom_target(genbits-cmake_format DEPENDS ${_genbits})
@@ -257,6 +257,7 @@
     index.rst
     installation.rst
     lint-example.rst
+    lint-inline.rst
     lint-notes.rst
     lint-summary.rst
     lint-usage.rst
@@ -295,9 +296,12 @@
 
 add_custom_command(
   OUTPUT ${_stage}/rtd-requirements.txt
-  COMMAND python -Bm cmake_format.tools.gen_rtd_requirements \$\${TRAVIS_TAG}
-          ${_src_version} -o ${_stage}/rtd-requirements.txt
-  DEPENDS ${CMAKE_SOURCE_DIR}/cmake_format/tools/gen_rtd_requirements.py
+  COMMAND
+    python -B ${TANGENT_TOOLING}/gen_rtd_requirements.py --tag from-travis
+    --version ${_src_version} -o ${_stage}/rtd-requirements.txt
+    ${CMAKE_CURRENT_SOURCE_DIR}/rtd-requirements.txt.in
+  DEPENDS ${TANGENT_TOOLING}/gen_rtd_requirements.py
+          ${CMAKE_CURRENT_SOURCE_DIR}/rtd-requirements.txt.in
   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 list(APPEND _genbits ${_stage}/rtd-requirements.txt)
 
@@ -315,7 +319,7 @@
 add_custom_target(
   clean-cmake_format-sphinx-stage
   DEPENDS ${_sphinx_manifest} ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST
-  COMMAND python -Bm tangent.tooling.clean_stage
+  COMMAND python -B ${TANGENT_TOOLING}/clean_stage.py
           ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST ${_stage}
   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
   COMMENT "Cleaning cmake_format/doc/stage")
@@ -325,6 +329,3 @@
   COMMAND env PYTHONPATH=${CMAKE_SOURCE_DIR} sphinx-build -M html ${_stage}
           ${CMAKE_CURRENT_BINARY_DIR}
   COMMAND touch ${CMAKE_CURRENT_BINARY_DIR}/html/index.html
-  DEPENDS clean-cmake_format-sphinx-stage ${_sphinx_manifest}
-          ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST ${CMAKE_SOURCE_DIR}/doc/conf.py
-  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}

=== cmake_format/test/CMakeLists.txt ===
add_test(
  NAME cmake_format-versionnumber-test
  COMMAND python -Bm cmake_format.test.version_number_test
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

add_test(
  NAME cmake_format-command-db-test
  COMMAND python -Bm cmake_format.test.command_db_test
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== cmake_format/vscode_extension/CMakeLists.txt ===
set(_copysrcs
    CHANGELOG.md
    images/cmake-format-logo.png
    images/small_demo.gif
    LICENSE
    package.json
    package-lock.json
    README.md
    src/extension.ts
    tsconfig.json
    tslint.json)

set(_copyfiles)
foreach(filename ${_copysrcs})
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${filename}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/${filename}
            ${CMAKE_CURRENT_BINARY_DIR}/${filename}
    DEPENDS ${filename}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  list(APPEND _copyfiles ${CMAKE_CURRENT_BINARY_DIR}/${filename})
endforeach()

# TODO(josh): glob the output tree so we can catch changes and accidental
# deletions
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/npm_install.stamp
  COMMAND npm install
  COMMAND touch npm_install.stamp
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS ${_copyfiles} package.json package-lock.json)

set(_baseImagesUrl "https://raw.githubusercontent.com/cheshirekow")
set(_baseImagesUrl "${_baseImagesUrl}/cmake_format/master/cmake_format")
set(_baseImagesUrl "${_baseImagesUrl}/vscode_extension")

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/cmake-format-${_extension_version}.vsix
  COMMAND ${CMAKE_CURRENT_BINARY_DIR}/node_modules/vsce/out/vsce package
          --baseImagesUrl ${_baseImagesUrl}
  DEPENDS ${_copyfiles} ${CMAKE_CURRENT_BINARY_DIR}/npm_install.stamp
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

add_custom_target(
  vscode-extension
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/cmake-format-${_extension_version}.vsix)

=== debian/changelog ===
cmake-format (0.6.11-1) unstable; urgency=medium

  * New upstream release.
  * Recomment python3-argcomplete since upstream now supports it.

 -- Ian Campbell <ijc@debian.org>  Sat, 18 Jul 2020 11:54:04 +0100

cmake-format (0.6.10-3) unstable; urgency=medium

  * Ensure pybuild chooses to use the disttools plugin (Closes: #963294).

 -- Ian Campbell <ijc@debian.org>  Sat, 27 Jun 2020 08:10:41 +0100

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,8 @@
 
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
+
+export PYBUILD_SYSTEM=distutils
 
 %:
 	# Force pybuild otherwise makefile is used.
